#version 120


#define WORLD_SPACE		//Implements the deformation in World Space. Uses Screen Space if not enabled.


uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

uniform float frameTimeCounter;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;


void main()
{
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
	
	#ifdef WORLD_SPACE
		position = gbufferModelViewInverse * position;
	#endif
	
	float distance2D = position.x * position.x + position.z * position.z;
	
	position.y -= min(distance2D / 20, 20);
	
	
	#ifdef WORLD_SPACE
		position = gbufferModelView * position;
	#endif
	
	gl_Position = gl_ProjectionMatrix * position;
	
	
	gl_FogFragCoord = sqrt(position.x * position.x + position.y * position.y + position.z * position.z);
	
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	
	color = gl_Color;
}